<template>
    <b-container>
        <h3>Classifica cumulativa</h3>
        <b-table
            id="table"
            bordered
            striped
            hover
            fixed
            :items="politici"
            :fields="fields"
        >
            <template #cell(edit)="row">
                <b-button @click="row.toggleDetails" variant="outline-primary" class="my-2 my-sm-0 btn-outline">
                    <b-icon v-if="!row.detailsShowing" icon="arrow-down"></b-icon>
                    <b-icon v-if="row.detailsShowing" icon="arrow-up"></b-icon>
                </b-button>
            </template>
            <template #row-details="row">
                <h5>Assegna punti</h5>
                <div class="edit">
                    <b-form-input type="number" id="points" class="input-margin" v-model="points_new_politic" placeholder="Punti"></b-form-input>
                    <b-button @click="addPoints(row.item)" variant="outline-primary" class="my-2 my-sm-0 btn-outline">Salva</b-button>
                </div>
            </template>
        </b-table>

    </b-container>
</template>

<script>
import axios from 'axios'

export default {
    name: 'RankingComponent',
    data() {
        return {
            politici: [],
            fields: [
                {key: "position", label: "Posizione", sortable: true},
                {key: "surname", label: "Cognome", sortable: true},
                {key: "name", label: "Nome", sortable: false},
                {key: "points", label: "Punti Assegnati", sortable: true},
                {key: "edit", label: "Modifica", sortable: false},
            ],
            name_new_politic: '',
            surname_new_politic: '',
            points_new_politic: '',
        }
    },
    methods: {
        convertDateFormat(date) {
            let dd = String(date.getDate()).padStart(2, '0')
            let mm = String(date.getMonth() + 1).padStart(2,'0')
            let yyyy = date.getFullYear()
            let result = yyyy + '-' + mm + '-' + dd
            return (result)
        },
        sort(politics) {
            let check = true
            while(check) {
                check = false
                for (let i = 0; i < (politics.length - 1); i++) {
                    if (politics[i].points < politics[i+1].points) {
                        check = true
                        let tmp = politics[i]
                        politics[i] = politics[i+1]
                        politics[i+1] = tmp
                    }
                }
            }
            for (let i = 0; i < politics.length; i++) {
                politics[i].position = i + 1
            }
            return (politics)
        },
        changeRanking(name, surname, points) {
            let check = false; let i = 0
            while (!check && i < this.politici.length) {
                let tmp = this.politici[i]
                if (tmp.name == name && tmp.surname == surname) {
                    this.politici[i].points += points
                    check = true
                }
                i++
            }
            let result = this.politici
            if (!check) {
                let tmp = {"position": 0, "name": name, "surname": surname, "points": points}
                result.push(tmp)
            }
            this.politici = this.sort(result)
            return this.politici
        },
        classifica: async function() {
            const today = this.convertDateFormat(new Date())
            const minDate = "2022-11-04"
            let res = await axios.get("http://localhost:8000/api/v1/getranking/"+minDate+"/"+today)
            this.politici = res.data
        },
        addPoints(politic) {
            console.log(politic)
            if (isNaN(this.points_new_politic)) {
                console.log("Non hai assegnato un punteggio valido!")
                return null
            }
            this.name_new_politic = politic.name;
            this.surname_new_politic = politic.surname;
            let values = [this.name_new_politic, this.surname_new_politic, this.points_new_politic]
            this.$root.$emit("getChangesByUser", (values))
        }
    },
    mounted() {
        this.$root.$on("getChangesByUser", input_array => {
            let name = input_array[0].toUpperCase()
            let surname = input_array[1].toUpperCase()
            let points = parseInt(input_array[2])
            this.politici = this.changeRanking(name, surname, points)
            return (this.politici)
        })
    },
    created: async function () {
        await this.classifica();
    }
}
</script>

<style scoped>
.edit {
    display: flex;
    align-items: center;
    justify-content: center;
    margin: 1rem auto;
}
.edit input {
    width: 20%;
    margin-right: 1rem;
}
h3 {
    margin-bottom: 1rem;
}
</style>
